modules/documents/controllers/DocumentController.php
<?php

namespace app\modules\documents\controllers;

use app\modules\admin\controllers\BaseController;
use app\modules\documents\models\Document;
use app\modules\documents\models\search\DocumentSearch;
use Yii;
use yii\filters\VerbFilter;
use yii\web\NotFoundHttpException;

/**
 * DocumentController implements the CRUD actions for Document model.
 */
class DocumentController extends BaseController
{
    /**
     * @inheritDoc
     */
    public function behaviors()
    {
        return array_merge(
            parent::behaviors(),
            [
                'verbs' => [
                    'class' => VerbFilter::className(),
                    'actions' => [
                        'delete' => ['POST'],
                    ],
                ],
            ]
        );
    }

    /**
     * Lists all Document models.
     *
     * @return string
     */
    public function actionIndex()
    {
        $searchModel = new DocumentSearch();
        $dataProvider = $searchModel->search($this->request->queryParams);

        return $this->render('index', [
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
        ]);
    }

    /**
     * Displays a single Document model.
     * @param int $id ID
     * @return string
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionView($id)
    {
        return $this->render('view', [
            'model' => $this->findModel($id),
        ]);
    }

    /**
     * Creates a new Document model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return string|\yii\web\Response
     */
    public function actionCreate($groupId = null)
    {
        $model = Yii::createObject(Document::class);
        if ($this->request->isPost) {
            if ($model->uploadAndSave(Yii::$app->user->identity->id)) {
                return $this->redirect(['index']);
            }

            if ($model->hasErrors()) {
                // Only when uploaded via Drag&drop?
                return $this->asJson([
                        'files' => [
                            [
                                'filename' => $model->getOrigFilename(),
                                'errors' => $model->getErrors('uploadedFile'),
                            ]
                        ]
                    ]);
            }
        } else {
            $model->loadDefaultValues();
        }

        return $this->render('create', [
            'model' => $model,
        ]);
    }

    /**
     * Updates an existing Document model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param int $id ID
     * @return string|\yii\web\Response
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionUpdate($id)
    {
        $model = $this->findModel($id);

        if ($this->request->isPost && $model->load($this->request->post()) && $model->save()) {
            //return $this->redirect(['view', 'id' => $model->id]);
            return $this->redirect(['index']);
        }

        return $this->render('update', [
            'model' => $model,
        ]);
    }

    /**
     * Deletes an existing Document model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param int $id ID
     * @return \yii\web\Response
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionDelete($id)
    {
        $this->findModel($id)->delete();

        return $this->redirect(['index']);
    }

    public function actionDropzoneUpload()
    {
        $document = new Document();
        if ($document->uploadAndSave(Yii::$app->user->identity->id)) {
            // here we can modify some related object
        } else {
            $error = $document->getErrorSummary(false);
            Yii::$app->session->setFlash('error', $error);
        }
    }

    public function actionGetUrl($id, $thumb = 0)
    {
        $model = $this->findModel($id);

        $path = $model->getPath();
        if ($thumb) {
            $path = $model->getThumbnailPath();
        }

        header('Content-Type: ' . $model->mime);

        if (trim($model->mime) == '') {
            header('Content-Type: application/octet-stream');
        }

        if (!file_exists($path)) {
            $path = realpath(__DIR__ . '/../unknown_file.svg');
            header('Content-Type: image/svg+xml');
        }

        header('Content-Description: File Transfer');
        header('Content-Disposition: attachment; filename=' . $model->getOrigFilename()); // basename($path)
        header('Content-Transfer-Encoding: binary');
        header('Expires: 0');
        header('Cache-Control: must-revalidate');
        header('Pragma: public');
        header('Content-Length: ' . filesize($path));
        if (ob_get_contents()) {
            ob_clean();
        }
        flush();
        readfile($path);

        // Or do we want to use fpassthru() instead of readfile().
        // @link https://www.php.net/manual/en/function.fpassthru.php
        // ...  But:
        // If you just want to dump the contents of a file to the output buffer,
        // without first modifying it or seeking to a particular offset,
        // you may want to use the readfile(), which saves you the fopen() call.

        exit;
    }

    /**
     * Finds the Document model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param int $id ID
     * @return Document the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = Document::findOne(['id' => $id])) !== null) {
            return $model;
        }

        throw new NotFoundHttpException(Yii::t('app', 'The requested page does not exist.'));
    }
}

modules/documents/controllers/DocumentGroupController.php
<?php

namespace app\modules\documents\controllers;

use app\modules\admin\controllers\BaseController;
use app\modules\documents\models\DocumentGroup;
use app\modules\documents\models\search\DocumentGroupItemSearch;
use app\modules\documents\models\search\DocumentGroupSearch;
use Yii;
use yii\data\ArrayDataProvider;
use yii\filters\VerbFilter;
use yii\helpers\ArrayHelper;
use yii\web\NotFoundHttpException;

/**
 * DocumentGroupController implements the CRUD actions for DocumentGroup model.
 */
class DocumentGroupController extends BaseController
{
    /**
     * @inheritDoc
     */
    public function behaviors()
    {
        return array_merge(
            parent::behaviors(),
            [
                'verbs' => [
                    'class' => VerbFilter::className(),
                    'actions' => [
                        'delete' => ['POST'],
                    ],
                ],
            ]
        );
    }

    /**
     * Lists all DocumentGroup models.
     *
     * @return string
     */
    public function actionIndex()
    {
        $searchModel = new DocumentGroupSearch();
        $dataProvider = $searchModel->search($this->request->queryParams);

        return $this->render('index', [
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
        ]);
    }

    /**
     * Displays a single DocumentGroup model.
     * @param int $id ID
     * @return string
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionView($id)
    {
        return $this->render('view', [
            'model' => $this->findModel($id),
        ]);
    }

    /**
     * Creates a new DocumentGroup model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return string|\yii\web\Response
     */
    public function actionCreate()
    {
        $model = new DocumentGroup();

        if ($this->request->isPost) {
            $model->id_user = Yii::$app->user->identity->id;
            if ($model->load($this->request->post()) && $model->save()) {
                return $this->redirect(['update', 'id' => $model->id]);
            }
        } else {
            $model->loadDefaultValues();
        }

        return $this->render('create', [
            'model' => $model,
        ]);
    }

    /**
     * Updates an existing DocumentGroup model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param int $id ID
     * @return string|\yii\web\Response
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionUpdate($id)
    {
        $model = $this->findModel($id);


        if ($this->request->isPost && $model->load($this->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->id]);
        }

        $searchModel_items = new DocumentGroupItemSearch();
        $dataProvider_items = $searchModel_items->search(['id_group' => $this->id]);
        $dataProvider_items->sort = [
            'defaultOrder' => [
                'position' => SORT_ASC,
            ]
        ];
        return $this->render('update', [
            'model' => $model,
            'searchModel_items' => $searchModel_items,
            'dataProvider_items' => $dataProvider_items,
        ]);
    }

    /**
     * Deletes an existing DocumentGroup model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param int $id ID
     * @return \yii\web\Response
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionDelete($id)
    {
        $this->findModel($id)->delete();

        return $this->redirect(['index']);
    }

    public function actionGallery($id)
    {
        $model = $this->findModel($id);

        $galleryDataProvider = new ArrayDataProvider([
            'allModels' => $model->items,
            'pagination' => [
                'pageSize' => 20,
            ],
        ]);

        return $this->render('gallery', [
            'galleryDataProvider' => $galleryDataProvider,
            'model' => $model,
        ]);
    }

    public function actionSort($id, $pjaxId = null)
    {
        $group = $this->findModel($id);
        $items = ArrayHelper::index($group->items, 'id');
        foreach (Yii::$app->request->post('position') as $i => $docGroupItemId) {
            if (isset($items[$docGroupItemId])) {
                $items[$docGroupItemId]->position = ($i + 1) * 1000;
                $items[$docGroupItemId]->save(false, ['position']);
            }
        }

        if ($pjaxId) {
            return '<script>'
                . "$.pjax.reload({container:'#$pjaxId'});"
                . "$('#myModalDialog').modal('hide');"
                . '</script>';
        }
    }

    /**
     * Finds the DocumentGroup model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param int $id ID
     * @return DocumentGroup the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = DocumentGroup::findOne(['id' => $id])) !== null) {
            return $model;
        }

        throw new NotFoundHttpException(Yii::t('app', 'The requested page does not exist.'));
    }
}

modules/documents/controllers/DocumentGroupItemController.php
<?php

namespace app\modules\documents\controllers;

use app\modules\admin\controllers\BaseController;
use app\modules\documents\models\DocumentGroupItem;
use app\modules\documents\models\search\DocumentGroupItemSearch;
use Yii;
use yii\filters\VerbFilter;
use yii\web\NotFoundHttpException;

/**
 * DocumentGroupItemController implements the CRUD actions for DocumentGroupItem model.
 */
class DocumentGroupItemController extends BaseController
{
    public $moreCoverDocumentsAllowed = false;

    /**
     * @inheritDoc
     */
    public function behaviors()
    {
        return array_merge(
            parent::behaviors(),
            [
                'verbs' => [
                    'class' => VerbFilter::className(),
                    'actions' => [
                        'delete' => ['POST'],
                    ],
                ],
            ]
        );
    }

    /**
     * Lists all DocumentGroupItem models.
     *
     * @return string
     */
    public function actionIndex()
    {
        $searchModel = new DocumentGroupItemSearch();
        $dataProvider = $searchModel->search($this->request->queryParams);

        return $this->render('index', [
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
        ]);
    }

    /**
     * Displays a single DocumentGroupItem model.
     * @param int $id ID
     * @return string
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionView($id)
    {
        return $this->render('view', [
            'model' => $this->findModel($id),
        ]);
    }

    /**
     * Creates a new DocumentGroupItem model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return string|\yii\web\Response
     */
    public function actionCreate($groupId = null, $pjaxId = null)
    {
        $model = new DocumentGroupItem();

        if ($groupId) {
            $model->document_group_id = $groupId;
        }

        if ($this->request->isPost) {
            if ($model->load($this->request->post()) && $model->save()) {
                if (Yii::$app->request->isAjax) {
                    return '<script>'
                        . "$.pjax.reload({container:'#$pjaxId'});"
                        . "$('#myModalDialog').modal('hide');"
                        . '</script>';
                }

                return $this->redirect(['view', 'id' => $model->id]);
            }
        } else {
            $model->loadDefaultValues();
        }

        return $this->render('create', [
            'model' => $model,
        ]);
    }

    /**
     * Updates an existing DocumentGroupItem model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param int $id ID
     * @return string|\yii\web\Response
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionUpdate($id, $pjaxId = null)
    {
        $model = $this->findModel($id);

        if ($this->request->isPost && $model->load($this->request->post()) && $model->save()) {
            if (Yii::$app->request->isAjax && $pjaxId) {
                return '<script>'
                    . "$.pjax.reload({container:'#$pjaxId'});"
                    . "$('#myModalDialog').modal('hide');"
                    . '</script>';
            }

            return $this->redirect(['view', 'id' => $model->id]);
        }

        return $this->render('update', [
            'model' => $model,
        ]);
    }

    /**
     * Deletes an existing DocumentGroupItem model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param int $id ID
     * @return \yii\web\Response
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionDelete($id, $pjaxId = null)
    {
        $this->findModel($id)->delete();

        if ($pjaxId) {
            return '<script>'
                . "$.pjax.reload({container:'#$pjaxId'});"
                . "$('#myModalDialog').modal('hide');"
                . '</script>';
        }

        return $this->redirect(['index']);
    }

    public function actionSetAsGroupCover($id, $pjaxId)
    {
        $item = $this->findModel($id);

        if (!$this->moreCoverDocumentsAllowed) {
            DocumentGroupItem::updateAll(['is_cover' => 0], [
                'document_group_id' => $item->document_group_id,
            ]);
        }

        $item->is_cover = !$item->is_cover;
        $item->save(false, ['is_cover']);

        return '<script>'
            . "$.pjax.reload({container:'#$pjaxId'});"
            . "$('#myModalDialog').modal('hide');"
            . '</script>';
    }

    public function actionToggle($id, $pjaxId)
    {
        $item = $this->findModel($id);
        $item->status = !$item->status;
        $item->save(false, ['status']);

        return '<script>'
            . "$.pjax.reload({container:'#$pjaxId'});"
            . "$('#myModalDialog').modal('hide');"
            . '</script>';
    }

    /**
     * Finds the DocumentGroupItem model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param int $id ID
     * @return DocumentGroupItem the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = DocumentGroupItem::findOne(['id' => $id])) !== null) {
            return $model;
        }

        throw new NotFoundHttpException(Yii::t('app', 'The requested page does not exist.'));
    }
}

modules/documents/views/document-group/_form.php
<?php

use app\modules\documents\models\DocumentGroup;
use yii\helpers\Html;
use yii\widgets\ActiveForm;

/** @var yii\web\View $this */
/** @var app\modules\documents\models\DocumentGroup $model */
/** @var yii\widgets\ActiveForm $form */
?>

<div class="document-group-form">

    <?php $form = ActiveForm::begin([
    ]); ?>

    <?= $form->field($model, 'group_type')->dropDownList(DocumentGroup::getType_listData()) ?>

    <?php // $form->field($model, 'id_user')->textInput() ?>

    <?= $form->field($model, 'position')->textInput() ?>

    <?= $form->field($model, 'status')->dropDownList(DocumentGroup::getStatus_listData()) ?>

    <?= $form->field($model, 'title')->textInput(['maxlength' => true]) ?>

    <?= $form->field($model, 'description')->textarea(['rows' => 6]) ?>

    <?= $form->field($model, 'active_from')->widget(app\widgets\DatePicker::class); ?>

    <?= $form->field($model, 'hidden_from')->widget(app\widgets\DatePicker::class); ?>

    <?php // $form->field($model, 'deleted_at')->textInput() ?>

    <div class="form-group">
        <?= Html::submitButton(Yii::t('app', 'Save'), ['class' => 'btn btn-success']) ?>
    </div>

    <?php ActiveForm::end(); ?>

</div>

modules/documents/views/document-group/_search.php
<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;

/** @var yii\web\View $this */
/** @var app\modules\documents\models\search\DocumentGroupSearch $model */
/** @var yii\widgets\ActiveForm $form */
?>

<div class="document-group-search">

    <?php $form = ActiveForm::begin([
        'action' => ['index'],
        'method' => 'get',
        'options' => [
            'data-pjax' => 1
        ],
    ]); ?>

    <?= $form->field($model, 'id') ?>

    <?= $form->field($model, 'group_type') ?>

    <?= $form->field($model, 'id_user') ?>

    <?= $form->field($model, 'position') ?>

    <?= $form->field($model, 'status') ?>

    <?php // echo $form->field($model, 'active_from')->textInput(['class' => 'form-control datepicker']) ?>

    <?php // echo $form->field($model, 'hidden_from')->textInput(['class' => 'form-control datepicker']) ?>

    <?php // echo $form->field($model, 'title') ?>

    <?php // echo $form->field($model, 'description') ?>

    <?php // echo $form->field($model, 'created_at') ?>

    <?php // echo $form->field($model, 'updated_at') ?>

    <?php // echo $form->field($model, 'deleted_at') ?>

    <div class="form-group">
        <?= Html::submitButton(Yii::t('app', 'Search'), ['class' => 'btn btn-primary']) ?>
        <?= Html::resetButton(Yii::t('app', 'Reset'), ['class' => 'btn btn-outline-secondary']) ?>
    </div>

    <?php ActiveForm::end(); ?>

</div>

modules/documents/views/document-group/create.php
<?php

/** @var yii\web\View $this */
/** @var app\modules\documents\models\DocumentGroup $model */

$this->title = Yii::t('app.documents', 'Create Document Group');
$this->params['breadcrumbs'][] = ['label' => Yii::t('app.documents', 'Document Groups'), 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="card">

    <div class="card-body">

        <?= $this->render('_form', [
            'model' => $model,
        ]) ?>

    </div>

</div>

modules/documents/views/document-group/gallery.php
<?php

use app\modules\documents\widgets\FileUpload;
use app\widgets\GalleryListView;
use yii\widgets\Pjax;

/** @var \yii\data\ArrayDataProvider $galleryDataProvider */
/** @var \app\modules\documents\models\DocumentGroup $model */

$this->title = Yii::t('app.documents', 'Gallery') . ' : ' . $model->title;
$this->params['breadcrumbs'][] = ['label' => Yii::t('app.documents', 'Document Groups'), 'url' => ['index']];
$this->params['breadcrumbs'][] = ['label' => $model->id, 'url' => ['view', 'id' => $model->id]];
$this->params['breadcrumbs'][] = Yii::t('app', 'Update');

//echo FileUpload::widget([
//    'uploadUrl' => Url::to(['document/create', 'groupId' => $model->id]),
//]);

echo '<br>';

Pjax::begin([
    'id' => 'gallery-pjax2',
    'enablePushState' => false,
    'enableReplaceState' => false
]);

echo GalleryListView::widget([
    'dataProvider' => $galleryDataProvider,
    'pjaxId' => 'gallery-pjax2',
    'galleryId' => $model->id,
]);

Pjax::end();

modules/documents/views/document-group/update.php
<?php

use app\modules\documents\widgets\FileUpload;

/** @var yii\web\View $this */
/** @var app\modules\documents\models\DocumentGroup $model */
/** @var app\modules\documents\models\DocumentGroup $model */

$this->title = Yii::t('app.documents', 'Update Document Group: {name}', [
    'name' => $model->id,
]);
$this->params['breadcrumbs'][] = ['label' => Yii::t('app.documents', 'Document Groups'), 'url' => ['index']];
$this->params['breadcrumbs'][] = ['label' => $model->id, 'url' => ['view', 'id' => $model->id]];
$this->params['breadcrumbs'][] = Yii::t('app', 'Update');

//echo FileUpload::widget([
//    'uploadUrl' => Url::to(['document/create', 'groupId' => $model->id]),
//]);
?>
<br>
<div class="card">

    <div class="card-body">

        <?= $this->render('_form', [
            'model' => $model,
        ]) ?>

    </div>

</div>

<div class="card">

    <div class="card-body">

        <?= $this->render('/document-group-item/index', [
            'searchModel' => $searchModel_items,
            'dataProvider' => $dataProvider_items,
            'showBreadcrumbs' => false,
            'groupId' => $model->id,
            'title' => $this->title,
        ]); ?>

    </div>

</div>

modules/documents/views/document-group/view.php
<?php

use yii\helpers\Html;
use yii\widgets\DetailView;

/** @var yii\web\View $this */
/** @var app\modules\documents\models\DocumentGroup $model */

$this->title = $model->title;
$this->params['breadcrumbs'][] = ['label' => Yii::t('app.documents', 'Document Groups'), 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
\yii\web\YiiAsset::register($this);
?>
<div class="card">

    <div class="card-body">

        <p>
            <?= Html::a(Yii::t('app', 'Update'), ['update', 'id' => $model->id], ['class' => 'btn btn-primary']) ?>
            <?= Html::a(Yii::t('app', 'Delete'), ['delete', 'id' => $model->id], [
                'class' => 'btn btn-danger',
                'data' => [
                    'confirm' => Yii::t('app', 'Are you sure you want to delete this item?'),
                    'method' => 'post',
                ],
            ]) ?>
        </p>

        <?= DetailView::widget([
            'model' => $model,
            'attributes' => [
                'id',
                'group_type',
                'id_user',
                'position',
                'status',
                'active_from',
                'hidden_from',
                'title',
                'description:ntext',
                'created_at',
                'updated_at',
                'deleted_at',
            ],
        ]) ?>

    </div>
</div>